<template>
  <dialog-confirmation
    v-bind="$attrs"
    :loading="loading"
    v-on="$listeners"
  >
    <template v-slot:title>
      <v-icon
        color="red"
        class="mr-2"
      >
        mdi-hand-back-left-outline
      </v-icon>
      {{ $t('areYouSure') }}
    </template>
    <div class="px-10 text-justify">
      <p>{{ $t('reviewBeforeDeleteWarning') }}</p>
      <p>
        <strong>
          <slot name="itemBeingDelete">
            {{ $t('itemBeingDelete', { entity: entityBeingDeleted, title: itemTitle, count: itemCount }) }}
          </slot>
        </strong>
      </p>
      <p>
        <slot name="whatWillHappenWhenDeleted">
          {{ $t('whatWillHappenWhenDeleted') }}
        </slot>
      </p>
      <p class="my-0">
        {{ $t('doYouWantToProceed') }}
      </p>
    </div>
  </dialog-confirmation>
</template>

<script>
  export default {
    name: 'CrudDataTableDelete',
    props: {
      entityBeingDeleted: {
        type: String,
        required: false,
      },
      itemBeingDeleted: {
        type: Object,
        required: true,
      },
      loading: {
        type: Boolean,
        default: false,
        required: false,
      },
    },
    computed: {
      isThereAItemBeingDeleted () {
        return !!this.itemBeingDeleted
      },
      itemTitle () {
        return this.isThereAItemBeingDeleted
          ? this.itemBeingDeleted.title
          : ''
      },
      itemCount () {
        return this.isThereAItemBeingDeleted
          ? this.itemBeingDeleted.count
          : ''
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          areYouSure: 'Tem certeza que deseja excluir este item definitivamente?',
          reviewBeforeDeleteWarning: 'Revise o que está sendo excluído antes de confirmar.',
          itemBeingDelete: '{entity}: {title} (utilizado(a) {count} vezes)',
          whatWillHappenWhenDeleted: 'Este item será removido de todos os lugares em que ele estiver sendo utilizado.',
          doYouWantToProceed: 'Deseja prosseguir com a exclusão?',
        },
        'en-US': {
          areYouSure: 'Are you sure you want to permanently delete this item?',
          reviewBeforeDeleteWarning: 'Review what is being deleted before confirming.',
          itemBeingDelete: '{entity}: {title} (used {count} times)',
          whatWillHappenWhenDeleted: 'This item will be removed from wherever it is being used.',
          doYouWantToProceed: 'Do you want to proceed with the deletion?',
        },
      },
    },
  }
</script>
